www.digitalmars.com         C & C++   DMDScript  

digitalmars.D.learn - How to kill whole application if child thread raises an exception?

reply dm <none email.com> writes:
Hi. I tried code below:

import std.concurrency;
import std.stdio;

void func()
{
     throw new Exception("I'm an exception");
}

void main()
{
     auto tID = spawn(&func);
     foreach(line; stdin.byLine)
         send(tID, "");
}

I expect my application will die immediatly, but main thread 
still running and I don't see any errors.
I want to kill all my threads if it is unhandled exception.
How can I do that?
Oct 26 2016
next sibling parent reply rikki cattermole <rikki cattermole.co.nz> writes:
On 26/10/2016 9:42 PM, dm wrote:
 Hi. I tried code below:

 import std.concurrency;
 import std.stdio;

 void func()
 {
     throw new Exception("I'm an exception");
 }

 void main()
 {
     auto tID = spawn(&func);
     foreach(line; stdin.byLine)
         send(tID, "");
 }

 I expect my application will die immediatly, but main thread still
 running and I don't see any errors.
 I want to kill all my threads if it is unhandled exception.
 How can I do that?
Simple, handle the exceptions on each thread.
Oct 26 2016
parent reply dm <none email.com> writes:
On Wednesday, 26 October 2016 at 08:53:13 UTC, rikki cattermole 
wrote:
 Simple, handle the exceptions on each thread.
I don't want handle exceptions. I want my application crash with exception description. Can you change my code above to show how it can be made?
Oct 26 2016
parent reply rikki cattermole <rikki cattermole.co.nz> writes:
Basically when you spawn a thread giving the function, you pass it 
through another function which will catch any exceptions not normally 
caught.

Of course this really should be the default behavior but somebody else 
may be more of a help here.

And it is pseudo code, so please don't expect it to 100% work as I have 
written it.

```D
void entryPoint(alias func)() {
	try {
		func();
	} catch (Exception e) {
		import std.stdio;
		writeln(e.toString());
	}
}

void main() {
	auto tid = spawn(&entryPoint!someFunc);
	// ...
	
}
```
Oct 26 2016
next sibling parent Basile B. <b2.temp gmx.com> writes:
On Wednesday, 26 October 2016 at 09:43:10 UTC, rikki cattermole 
wrote:
 Basically when you spawn a thread giving the function, you pass 
 it through another function which will catch any exceptions not 
 normally caught.

 Of course this really should be the default behavior but 
 somebody else may be more of a help here.

 And it is pseudo code, so please don't expect it to 100% work 
 as I have written it.

 ```D
 void entryPoint(alias func)() {
 	try {
 		func();
 	} catch (Exception e) {
 		import std.stdio;
 		writeln(e.toString());
 	}
 }

 void main() {
 	auto tid = spawn(&entryPoint!someFunc);
 	// ...
 	
 }
 ```
It doesn't return. It still have to be killed by hand. (at least on Linux)
Oct 26 2016
prev sibling parent reply dm <none email.com> writes:
On Wednesday, 26 October 2016 at 09:43:10 UTC, rikki cattermole 
wrote:
 ```D
 void entryPoint(alias func)() {
 	try {
 		func();
 	} catch (Exception e) {
 		import std.stdio;
 		writeln(e.toString());
 	}
 }

 void main() {
 	auto tid = spawn(&entryPoint!someFunc);
 	// ...
 	
 }
 ```
Well... This code shows me: object.Exception thread.d(6): I'm an exception ---------------- But my main thread still working :( Why so strange default behavior do not kill other threads in case some of threads raise exception? But thanks anyway.
Oct 26 2016
next sibling parent reply rikki cattermole <rikki cattermole.co.nz> writes:
On 26/10/2016 11:03 PM, dm wrote:
 On Wednesday, 26 October 2016 at 09:43:10 UTC, rikki cattermole wrote:
 ```D
 void entryPoint(alias func)() {
     try {
         func();
     } catch (Exception e) {
         import std.stdio;
         writeln(e.toString());
     }
 }

 void main() {
     auto tid = spawn(&entryPoint!someFunc);
     // ...

 }
 ```
Well... This code shows me: object.Exception thread.d(6): I'm an exception ---------------- But my main thread still working :( Why so strange default behavior do not kill other threads in case some of threads raise exception? But thanks anyway.
If you throw an error it should crash the entire application. But really you need to set up sync points within your application to allow it to die gracefully.
Oct 26 2016
parent dm <none email.com> writes:
On Wednesday, 26 October 2016 at 10:09:05 UTC, rikki cattermole 
wrote:
 If you throw an error it should crash the entire application.
 But really you need to set up sync points within your 
 application to allow it to die gracefully.
I tried throw new Error... But main thread still working. Tried with dmd v2.071.2 and ldc2 0.17.2. OS - Linux.
Oct 26 2016
prev sibling parent Kagamin <spam here.lot> writes:
On Wednesday, 26 October 2016 at 10:03:30 UTC, dm wrote:
 Why so strange default behavior do not kill other threads in 
 case some of threads raise exception?
 But thanks anyway.
AFAIK, on posix you should join the child thread, and when you do, the stored exception is rethrown in the joining thread.
Oct 26 2016
prev sibling next sibling parent Paolo Invernizzi <paolo.invernizzi no.address> writes:
On Wednesday, 26 October 2016 at 08:42:02 UTC, dm wrote:
 Hi. I tried code below:

 import std.concurrency;
 import std.stdio;

 void func()
 {
     throw new Exception("I'm an exception");
 }

 void main()
 {
     auto tID = spawn(&func);
     foreach(line; stdin.byLine)
         send(tID, "");
 }

 I expect my application will die immediatly, but main thread 
 still running and I don't see any errors.
 I want to kill all my threads if it is unhandled exception.
 How can I do that?
You need to link the threads, and at least one receive after the child thread has implicitly sent the exception to the main thread: import std.concurrency; import std.stdio; --- void func() { throw new Exception("I'm an exception"); } void main() { auto tID = spawnLinked(&func); receive((int dummy){}); } --- /Paolo
Oct 26 2016
prev sibling next sibling parent Adam D. Ruppe <destructionator gmail.com> writes:
On Wednesday, 26 October 2016 at 08:42:02 UTC, dm wrote:
 I want to kill all my threads if it is unhandled exception.
 How can I do that?
The spawnLinked function might help: http://dpldocs.info/experimental-docs/std.concurrency.spawnLinked.html http://dlang.org/phobos/std_concurrency.html#spawnLinked " This new thread is linked to the calling thread so that if either it or the calling thread terminates a LinkTerminated message will be sent to the other, causing a LinkTerminated exception to be thrown on receive()." At least that sounds basically right.
Oct 26 2016
prev sibling next sibling parent dm <none email.com> writes:
Thanks all.
I gues I must rewrote my app to send exeptions to other threads, 
use non blocking io, etc, etc.
Oct 26 2016
prev sibling parent reply Steven Schveighoffer <schveiguy yahoo.com> writes:
On 10/26/16 4:42 AM, dm wrote:
 Hi. I tried code below:

 import std.concurrency;
 import std.stdio;

 void func()
 {
     throw new Exception("I'm an exception");
 }

 void main()
 {
     auto tID = spawn(&func);
     foreach(line; stdin.byLine)
         send(tID, "");
 }

 I expect my application will die immediatly, but main thread still
 running and I don't see any errors.
 I want to kill all my threads if it is unhandled exception.
 How can I do that?
Hm... what about: import std.traits: Parameters; auto mySpawn(F)(F func, Parameters!F params) { static auto callIt(F func, Parameters!F params) { try { return func(params); } catch(Throwable t) { // print the exception/error, e.g.: import std.writeln; writeln(e.toString()); // terminate program import core.stdc.stdlib : exit; exit(1); } } return spawn(&callIt, func, params); } void main() { auto tID = mySpawn(&func); ... } -Steve
Oct 27 2016
next sibling parent reply dm <none email.com> writes:
On Thursday, 27 October 2016 at 13:37:29 UTC, Steven 
Schveighoffer wrote:
 Hm... what about:
 ...
Main thread still running.
Oct 27 2016
parent reply dm <none email.com> writes:
On Friday, 28 October 2016 at 03:38:05 UTC, dm wrote:
 On Thursday, 27 October 2016 at 13:37:29 UTC, Steven 
 Schveighoffer wrote:
 Hm... what about:
 ...
Main thread still running.
Actually it's depends on compiler. With ldc2 main thread doesn't stop, but with dmd seems all ok: root proxytest:~# ./newthread object.Exception newthread.d(30): Everything is bad. ---------------- ??:? void newthread.func() [0x451f52] ??:? void newthread.mySpawn!(void function()*).mySpawn(void function()*).callIt(void function()*) [0x452037] ??:? void std.concurrency._spawn!(void function(void function()*)*, void function()*)._spawn(bool, void function(void function()*)*, void function()*).exec() [0x4529f4] ??:? void core.thread.Thread.run() [0x46f1f1] ??:? thread_entryPoint [0x46ef1b] ??:? [0x42d00a3] uncaught exception dwarfeh(224) fatal error Aborted
Oct 27 2016
parent dm <none email.com> writes:
I found http://arsdnet.net/this-week-in-d/2016-aug-07.html
Maybe it's helps me.
Oct 27 2016
prev sibling parent dm <none email.com> writes:
On Thursday, 27 October 2016 at 13:37:29 UTC, Steven 
Schveighoffer wrote:
 Hm... what about:

 import std.traits: Parameters;

 auto mySpawn(F)(F func, Parameters!F params)
 {
     static auto callIt(F func, Parameters!F params)
     {
         try
         {
             return func(params);
         }
         catch(Throwable t)
         {
             // print the exception/error, e.g.:
             import std.writeln;
             writeln(e.toString());
             // terminate program
             import core.stdc.stdlib : exit;
             exit(1);
         }
     }

     return spawn(&callIt, func, params);
 }

 void main()
 {
     auto tID = mySpawn(&func);
     ...
 }

 -Steve
I found the solution which works with dmd and ldc2: ... import core.stdc.stdlib: _Exit; _Exit(exitcode); ...
Oct 27 2016